﻿using Syncfusion.Pdf;
using Syncfusion.Pdf.Graphics;
using Syncfusion.Pdf.Parsing;
using System;
using System.Collections.Generic;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Web;
using System.Web.Mvc;

namespace PDFSample.Controllers
{
    public class HomeController : Controller
    {
        public ActionResult Index()
        {
            ViewBag.Message = "Modify this template to jump-start your ASP.NET MVC application.";

            return View();
        }

        public ActionResult About()
        {
            ViewBag.Message = "Your app description page.";

            return View();
        }

        public ActionResult Contact()
        {
            ViewBag.Message = "Your contact page.";

            return View();
        }
        public ActionResult GeneratePDF()
        {
            //Loads the PDF document which c images
            PdfLoadedDocument loadedDocument = new PdfLoadedDocument(Server.MapPath("../App_Data/example.pdf"));          

            //Create a new PDF document
            PdfDocument doc = new PdfDocument();

            //Iterates all the pages to replace images
            foreach (PdfPageBase page in loadedDocument.Pages)
            {
                //Extracts the images from the document
                Image[] extractedImages = page.ExtractImages();

                //Iterates all the image
                for (int j = 0; j < extractedImages.Count(); j++)
                {
                    //Load the image
                    PdfBitmap img = new PdfBitmap(extractedImages[j]);

                    //Add a new PDF page
                    PdfPage newpage = doc.Pages.Add();

                    //Draw the image to the new page.
                    newpage.Graphics.DrawImage(img,new RectangleF(0,0,newpage.GetClientSize ().Width ,newpage.GetClientSize ().Height));
                }
            }

            //Save the document
            MemoryStream ms = new MemoryStream();
            doc.Save(ms); 
        
            Response.Clear();
            Response.ClearHeaders();
            Response.Buffer = true;
            Response.AddHeader("Content-Length", ms.Length.ToString());
            Response.AddHeader("Content-Disposition", "output.pdf");
            Response.ContentType = "application/pdf";
            Response.BinaryWrite(ms.GetBuffer());
            Response.Flush();
            Response.End();

            //Close the document
            loadedDocument.Close(true);
            doc.Close(true);
            return View();
        }
        
    }
}
